PrefabFiles = {
	"wakes",
	"wakes_feather",
	"wakes_spear",
	"wakes_helmet",
	"wakes_armor",
	"wakes_backpack",
	"wakes_eggs",
}
GetPlayer = GLOBAL.GetPlayer
Assets = {
    Asset( "IMAGE", "images/saveslot_portraits/wakes.tex" ),
    Asset( "ATLAS", "images/saveslot_portraits/wakes.xml" ),

    Asset( "IMAGE", "images/selectscreen_portraits/wakes.tex" ),
    Asset( "ATLAS", "images/selectscreen_portraits/wakes.xml" ),
	
    Asset( "IMAGE", "images/selectscreen_portraits/wakes_silho.tex" ),
    Asset( "ATLAS", "images/selectscreen_portraits/wakes_silho.xml" ),

    Asset( "IMAGE", "bigportraits/wakes.tex" ),
    Asset( "ATLAS", "bigportraits/wakes.xml" ),
	
	Asset( "IMAGE", "images/map_icons/wakes.tex" ),
	Asset( "ATLAS", "images/map_icons/wakes.xml" ),
	
	Asset("SOUNDPACKAGE", "sound/wakes.fev"),
	Asset("SOUND", "sound/wakes.fsb"),    
}

RemapSoundEvent("dontstarve/characters/wakes", "wakes/wakes")
RemapSoundEvent("dontstarve/characters/wakes/talk_LP", "wakes/wakes/talk_LP")
RemapSoundEvent("dontstarve/characters/wakes/ghost_LP", "wakes/wakes/ghost_LP")
RemapSoundEvent("dontstarve/characters/wakes/hurt", "wakes/wakes/hurt")
RemapSoundEvent("dontstarve/characters/wakes/death_voice", "wakes/wakes/death_voice")
RemapSoundEvent("dontstarve/characters/wakes/emote", "wakes/wakes/emote")
RemapSoundEvent("dontstarve/characters/wakes/pose", "wakes/wakes/pose")
RemapSoundEvent("dontstarve/characters/wakes/yawn", "wakes/wakes/yawn")

local require = GLOBAL.require
local TECH = GLOBAL.TECH
local Ingredient = GLOBAL.Ingredient
local RECIPETABS = GLOBAL.RECIPETABS
local STRINGS = GLOBAL.STRINGS
local resolvefilepath = GLOBAL.resolvefilepath
local ACTIONS = GLOBAL.ACTIONS
local Action = GLOBAL.Action

---Feather Growth Stuff

function featherpostinit(inst)
    -- Original function
    inst.Reset_pre = inst.Reset  

    -- Override the class function
    inst.Reset = function(self)
        
        if self.inst.prefab == "wakes" then
            local current_stage_found = nil
            
            for day = self.daysgrowth, 0, -1 do
                local cb = self.callbacks[day]
                if cb then
                    if current_stage_found then
                        cb()
                        self.daysgrowth = day

                        break
                    else
                        current_stage_found = true
                    end
                else
                    --self.inst.AnimState:ClearOverrideSymbol("beard")
					self.daysgrowth = 0
                    self.bits = 0
					if not self.inst:HasTag("IsNotHooded") then
					self.inst.components.temperature.inherentinsulation = (60)
					self.inst.components.health:SetAbsorptionAmount(0.50)
					self.inst.AnimState:SetBuild("wakes_hood")
					else
					self.inst.components.temperature.inherentinsulation = (0)
					self.inst.components.health:SetAbsorptionAmount(0)
                    self.inst.AnimState:SetBuild("wakes")
					end
                end
            end
        else
            self:Reset_pre()
        end 
    end
end

---Hood Wearing Stuff

local function WearHood(inst)
    if inst:HasTag("IsNotHooded") then ---Pull Up Hood
		local headitem = inst.components.inventory:GetEquippedItem(GLOBAL.EQUIPSLOTS.HEAD)
		if inst.components.inventory:GetEquippedItem(GLOBAL.EQUIPSLOTS.HEAD) then
			inst.components.inventory:Unequip(GLOBAL.EQUIPSLOTS.HEAD)
			inst.components.inventory:GiveItem(headitem)
			inst.AnimState:OverrideSymbol("swap_hat", "nil", "nil")
		end
		inst.SoundEmitter:PlaySound("dontstarve/wilson/backpack_close", "open")
		inst.components.temperature.inherentinsulation = (60)
		inst.components.health:SetAbsorptionAmount(0.50)
		inst:RemoveTag("IsNotHooded")
		if inst:HasTag("NoFeathers") then
			inst.AnimState:SetBuild("wakes_hood")
		elseif inst:HasTag("ShortFeathers") then
			inst.AnimState:SetBuild("wakes_hood_short")
		elseif inst:HasTag("MedFeathers") then
			inst.AnimState:SetBuild("wakes_hood_med")
		elseif inst:HasTag("LongFeathers") then
			inst.AnimState:SetBuild("wakes_hood_long")
		end
	elseif not inst:HasTag("IsNotHooded") then ---Pull Down Hood
		inst.SoundEmitter:PlaySound("dontstarve/wilson/backpack_open", "open")
		inst.components.temperature.inherentinsulation = (0)
		inst.components.health:SetAbsorptionAmount(0)
		inst:AddTag("IsNotHooded")
		if inst:HasTag("NoFeathers") then
			inst.AnimState:SetBuild("wakes")
		elseif inst:HasTag("ShortFeathers") then
			inst.AnimState:SetBuild("wakes_short")
		elseif inst:HasTag("MedFeathers") then
			inst.AnimState:SetBuild("wakes_med")
		elseif inst:HasTag("LongFeathers") then
			inst.AnimState:SetBuild("wakes_long")
		end
    end
end

GLOBAL.TheInput:AddKeyDownHandler(GetModConfigData("key_wakes"), function(player)
	WearHood(GetPlayer())
end)



-- Beard function override
AddComponentPostInit("beard", featherpostinit)

---Unique Introduction
local function MaxwellIntroWakes(inst)
    if GLOBAL.GetPlayer().prefab == "wakes" then
        inst.components.maxwelltalker.speeches.SANDBOX_1 =
        {
			appearsound = "dontstarve/maxwell/appear_adventure",
			voice = "dontstarve/maxwell/talk_LP_world1",
			appearanim = "appear2",
			idleanim= "idle2_loop",
			dialogpreanim = "dialog2_pre",
			dialoganim="dialog2_loop",
			dialogpostanim = "dialog2_pst",
			disappearanim = "disappear2",
			disableplayer = true,
            skippable = false,
            {
                string = "Tidings, Miss Veesk-Eix.",
                wait = 2,
                anim = nil,
                sound = nil,
            },
            {
                string = "Or should I say 'Takes-the-Shot'.",  
                wait = 3,
                anim = nil,
                sound = nil,
            },
			{
                string = "I fufilled my side of the bargain, now it's your turn.",  
                wait = 4,
                anim = nil,
                sound = nil,
            },
			{
                string = "I hope you can keep up that ignorant facade.",  
                wait = 4,
                anim = nil,
                sound = nil,
            },
        }
    end
end

AddPrefabPostInit("maxwellintro", MaxwellIntroWakes)

local function PlayPecks(inst)
	inst:RemoveEventCallback("animover", PlayPecks)
	local peckfn = function() 
		if inst then 
			inst.SoundEmitter:PlaySound("dontstarve_DLC002/creatures/parrot/peck") 
		end
	end
	inst:DoTaskInTime(6 * GLOBAL.FRAMES, peckfn)
	inst:DoTaskInTime(11 * GLOBAL.FRAMES, peckfn)
end

---Unique Introduction for the Shipwrecked DLC

local function ModWollyIntro(inst)
    if GLOBAL.GetPlayer().prefab == "wakes" then
		local TakeOff = inst.components.maxwelltalker.speeches.SHIPWRECKED_1.disappearanim
        inst.components.maxwelltalker.speeches.SHIPWRECKED_1 =
        {
			voice = "dontstarve_DLC002/creatures/parrot/chirp",
			idleanim = "idle",
			dialoganim = "speak",
			disappearanim = TakeOff,
			disableplayer = true,
			skippable = true,
			{
				string = nil,
				wait = 1,
				anim = "idle",
				pushanim = true,
				sound = nil,
			},
			{
				string = "Squawk! Nice shipwreck, love.",
				wait = 2,
				anim = nil,
				sound = nil,
			},
			{
				string = nil,
				wait = 1.5,
				anim = "idle_peck",
				pushanim = true,
				sectionfn = function(inst)
					inst:ListenForEvent("animover", PlayPecks)
				end,
			},
			{
				string = "I thought Argonians were supposed to be GOOD at swimming?", 
				wait = 3, 
				anim = nil, 
				sound = nil,
			},
						{
				string = nil,
				wait = 1.5,
				anim = "idle_peck",
				pushanim = true,
				sectionfn = function(inst)
					inst:ListenForEvent("animover", PlayPecks)
				end,
			},
			{
				string = "Pond-Scum.", 
				wait = 1, 
				anim = nil, 
				sound = nil,
			},
        }
    end
end

AddPrefabPostInit("wallyintro", ModWollyIntro)

-- The character select screen lines
GLOBAL.STRINGS.CHARACTER_TITLES.wakes = "The Lukiul"
GLOBAL.STRINGS.CHARACTER_NAMES.wakes = "Takes the Shot"
GLOBAL.STRINGS.CHARACTER_DESCRIPTIONS.wakes = "*Is an Argonian\n*Has nice clothes\n*Grows a hideous plume of feathers"
GLOBAL.STRINGS.CHARACTER_QUOTES.wakes = "\"Look alive, will you?\""

-- Custom speech strings
GLOBAL.STRINGS.CHARACTERS.WAKES = require "speech_wakes"
-- Let the game know character is male, female, or robot
table.insert(GLOBAL.CHARACTER_GENDERS.FEMALE, "wakes")

--- She likes eating bug-based food

---Butterfly wings
    AddPrefabPostInit("butterflywings", function(inst)
        if GetPlayer().prefab == "wakes" then
            inst.components.edible.sanityvalue = 6
        end
    end)
	
---Buttermuffin
    AddPrefabPostInit("butterflymuffin", function(inst)
        if GetPlayer().prefab == "wakes" then
            inst.components.edible.sanityvalue = 25
        end
    end)
	
---Butter
    AddPrefabPostInit("butter", function(inst)
        if GetPlayer().prefab == "wakes" then
            inst.components.edible.sanityvalue = 50
        end
    end)
	
---Glommer's Goop (Kinda, it's still a bit gross.)
    AddPrefabPostInit("glommerfuel", function(inst)
        if GetPlayer().prefab == "wakes" then
            inst.components.edible.sanityvalue = -10
        end
    end)
	
---Likes Glommer a bit more, obviously
    AddPrefabPostInit("glommer", function(inst)
        if GetPlayer().prefab == "wakes" then
            inst.components.sanityaura.aura = TUNING.SANITYAURA_LARGE*1.25
        end
    end)
	
---Hamlet Foods

---Gummy Slugs
    AddPrefabPostInit("slugbug", function(inst)
        if GetPlayer().prefab == "wakes" then
			inst.components.edible.sanityvalue = 8
        end
    end)
	
---Cooked Gummy Slugs
    AddPrefabPostInit("slugbug_cooked", function(inst)
        if GetPlayer().prefab == "wakes" then
			inst.components.edible.sanityvalue = 12
        end
    end)

---Gummy Cake
    AddPrefabPostInit("gummy_cake", function(inst)
        if GetPlayer().prefab == "wakes" then
			inst.components.edible.healthvalue = 10
			inst.components.edible.sanityvalue = 15
        end
    end)	
	
---Bean Bugs
    AddPrefabPostInit("jellybug", function(inst)
        if GetPlayer().prefab == "wakes" then
			inst.components.edible.sanityvalue = 5
        end
    end)
	
---Cooked Bean Bugs
    AddPrefabPostInit("jellybug_cooked", function(inst)
        if GetPlayer().prefab == "wakes" then
			inst.components.edible.sanityvalue = 8
        end
    end)

---Fiejoada
    AddPrefabPostInit("feijoada", function(inst)
        if GetPlayer().prefab == "wakes" then
			inst.components.edible.sanityvalue = 30
        end
    end)
	
---Hard Shell Tacos
    AddPrefabPostInit("hardshell_tacos", function(inst)
        if GetPlayer().prefab == "wakes" then
			inst.components.edible.sanityvalue = 20
        end
    end)

---Poison Frog Legs
    AddPrefabPostInit("froglegs_poison", function(inst)
        if GetPlayer().prefab == "wakes" then
			inst.components.edible.healthvalue = 0
        end
    end)
	
---Cooked Poison Frog Legs
    AddPrefabPostInit("froglegs_poison_cooked", function(inst)
        if GetPlayer().prefab == "wakes" then
			inst.components.edible.healthvalue = 0
        end
    end)
	
---She grows feathers

STRINGS.NAMES.WAKES_FEATHER = "Shed Feather"

---She can make stuff with those feathers

---A Spear

STRINGS.NAMES.WAKES_SPEAR = "Saxhleel Spear"
STRINGS.RECIPE_DESC.WAKES_SPEAR = "Waterproof and hurts like a Waxhuthi."

---A Battle Helmet

STRINGS.NAMES.WAKES_HELMET = "Saxhleel Helmet"
STRINGS.RECIPE_DESC.WAKES_HELMET = "Reel-Ka ready and Water-repellent."

---Some Armour

STRINGS.NAMES.WAKES_ARMOR = "Saxhleel Armour"
STRINGS.RECIPE_DESC.WAKES_ARMOR = "Tough but still ready for a Tsona."

---A 'Authentic' Argonian Backpack

STRINGS.NAMES.WAKES_BACKPACK = "'Saxhleel' Satchel"
STRINGS.RECIPE_DESC.WAKES_BACKPACK = "Large luggage for lazy Lukiul."

---She can cook her favourite snack

STRINGS.NAMES.WAKES_EGGS = "Chaurus Eggs"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.WAKES_EGGS = "These don't look safe for consumption."
STRINGS.RECIPE_DESC.WAKES_EGGS = "Eggs for an Egg-Sister."

AddPrefabPostInit("wakes_eggs", function(inst)
    if GetPlayer().prefab == "wakes" then
		local wakes_eggs = {
		name = "wakes_eggs",
		test = function(cooker, names, tags) return (names.tallbirdegg or names.tallbirdegg_cooked or names.doydoyegg or names.doydoyegg_cooked or names.spidereggsack) and (names.wormlight or names.bioluminescence or names.slugbug or names.slugbug_cooked or names.rainbowjellyfish_dead or names.rainbowjellyfish_cooked) and not tags.meat end,
		priority = 10,
		weight = 1,
		foodtype="MEAT",
		perishtime = TUNING.PERISH_MED,
		cooktime = 1,}

	AddIngredientValues({"tallbirdegg"}, {blue_egg=1})
	AddIngredientValues({"tallbirdegg_cooked"}, {blue_egg=1})
	AddIngredientValues({"doydoyegg"}, {blue_egg=1})
	AddIngredientValues({"doydoyegg_cooked"}, {blue_egg=1})
	AddIngredientValues({"spidereggsack"}, {blue_egg=1})
	AddIngredientValues({"wormlight"}, {blue_glow=1})
	AddIngredientValues({"rainbowjellyfish_dead"}, {blue_glow=1})
	AddIngredientValues({"rainbowjellyfish_cooked"}, {blue_glow=1})
	AddIngredientValues({"bioluminescence"}, {blue_glow=1})
	AddIngredientValues({"slugbug"}, {blue_glow=1})
	AddIngredientValues({"slugbug_cooked"}, {blue_glow=1})
	AddCookerRecipe("cookpot", wakes_eggs)
        	
	inst.components.edible.healthvalue = 50
	inst.components.edible.hungervalue = 75
	inst.components.edible.sanityvalue = 50
	
	---Oh and she can also substitute spider eggs for regular eggs...
	AddIngredientValues({"spidereggsack"}, {egg=4})
    end
end)
	

AddMinimapAtlas("images/map_icons/wakes.xml")
AddModCharacter("wakes")

