local assets=
{
	Asset("ANIM", "anim/wakes_armor.zip"),
	
	    
	Asset("ATLAS", "images/inventoryimages/wakes_armor.xml"),
    Asset("IMAGE", "images/inventoryimages/wakes_armor.tex"),
}

local function OnBlocked(owner) 
    owner.SoundEmitter:PlaySound("dontstarve/wilson/hit_armour") 
end

local function onequip(inst, owner) 
	owner.AnimState:OverrideSymbol("swap_body", "wakes_armor", "swap_body")
	owner:AddTag("wakes_armor")

	inst:ListenForEvent("blocked", OnBlocked, owner)
	inst:ListenForEvent("attacked", OnBlocked, owner)
end

local function onunequip(inst, owner) 
	owner.AnimState:ClearOverrideSymbol("swap_body")
	owner:RemoveTag("wakes_armor")

	inst:RemoveEventCallback("blocked", OnBlocked, owner)
	inst:RemoveEventCallback("attacked", OnBlocked, owner)
end

local function fn(Sim)
	local inst = CreateEntity()
	local trans = inst.entity:AddTransform()
	local anim = inst.entity:AddAnimState()
	MakeInventoryPhysics(inst)
	
	if IsDLCEnabled(PORKLAND_DLC) or IsDLCEnabled(CAPY_DLC) then
		-- Make floatable
		MakeInventoryFloatable(inst, "idle_water", "idle")
	end

    anim:SetBank("wakes_armor")
    anim:SetBuild("wakes_armor")
    anim:PlayAnimation("idle")

    inst:AddTag("wood")
    inst:AddComponent("inspectable")
    inst:AddComponent("inventoryitem")
    inst.components.inventoryitem.foleysound = "dontstarve/movement/foley/logarmour"
	inst.components.inventoryitem.imagename = "wakes_armor"
    inst.components.inventoryitem.atlasname = "images/inventoryimages/wakes_armor.xml"
    
	inst:AddComponent("fuel")
    inst.components.fuel.fuelvalue = TUNING.LARGE_FUEL
    
    inst:AddComponent("armor")
    inst.components.armor:InitCondition(TUNING.ARMORWOOD*2.5, TUNING.ARMORWOOD_ABSORPTION)
	
	inst:AddComponent("waterproofer")
    inst.components.waterproofer.effectiveness = 0
    
    inst:AddComponent("equippable")
    inst.components.equippable.equipslot = EQUIPSLOTS.BODY
    
	if IsDLCEnabled(PORKLAND_DLC) then
	inst:AddTag("venting")
	inst:AddTag("fogproof")
	end
	
    inst.components.equippable:SetOnEquip( onequip )
    inst.components.equippable:SetOnUnequip( onunequip )
    
    return inst
end

return Prefab( "common/inventory/wakes_armor", fn, assets) 