local assets =
{
    Asset("ANIM", "anim/wakes_eggs.zip"),
	
	Asset("ATLAS", "images/inventoryimages/wakes_eggs.xml"),
    Asset("IMAGE", "images/inventoryimages/wakes_eggs.tex"),
}

local prefabs =
		{
			"wakes_eggs",
				
		} 
		

	
local function fn(Sim)
    local inst = CreateEntity()

    inst.entity:AddTransform()
    inst.entity:AddAnimState()

    MakeInventoryPhysics(inst)
	
	if IsDLCEnabled(PORKLAND_DLC) or IsDLCEnabled(CAPY_DLC) then
		-- Make floatable
		MakeInventoryFloatable(inst, "idle_water", "idle")
	end
	

    inst.AnimState:SetBank("wakes_eggs")
    inst.AnimState:SetBuild("wakes_eggs")
    inst.AnimState:PlayAnimation("idle", true)
    inst:AddComponent("stackable")
    inst.components.stackable.maxsize = TUNING.STACK_SIZE_SMALLITEM

    inst:AddComponent("inspectable")

    inst:AddComponent("inventoryitem")
    inst.components.inventoryitem.imagename = "wakes_eggs"
    inst.components.inventoryitem.atlasname = "images/inventoryimages/wakes_eggs.xml"
	
	inst:AddTag("preparedfood")
	
    inst:AddComponent("edible")
	inst.components.edible.healthvalue = -50
	inst.components.edible.hungervalue = 75
	inst.components.edible.sanityvalue = -50
	inst.components.edible.foodtype = "MEAT"
	inst:AddComponent("perishable")
	inst.components.perishable:SetPerishTime(TUNING.PERISH_PRESERVED*2)
	inst.components.perishable:StartPerishing()
	inst.components.perishable.onperishreplacement = "rottenegg"
	
	inst:AddComponent("tradable")
	inst.components.tradable.goldvalue = 5
	
	
---It glows! Healthy!
	local light = inst.entity:AddLight()
    light:SetFalloff(0.7)
    light:SetIntensity(.15)
    light:SetRadius(0.5)
    light:SetColour(172/255, 247/255, 246/255)
    light:Enable(true)
    inst.AnimState:SetBloomEffectHandle( "shaders/anim.ksh" )
    inst.components.inventoryitem:SetOnDroppedFn(function() inst.Light:Enable(true) end)
    inst.components.inventoryitem:SetOnPickupFn(function() inst.Light:Enable(false) end)
    return inst
end


return Prefab("common/inventory/wakes_eggs", fn, assets, prefabs)
	
