local assets=
{ 
    Asset("ANIM", "anim/wakes_feather.zip"),
    Asset("ATLAS", "images/inventoryimages/wakes_feather.xml"),
}

local function fn(Sim)
	local inst = CreateEntity()
	inst.entity:AddTransform()
	inst.entity:AddAnimState()

    MakeInventoryPhysics(inst)
		
	if IsDLCEnabled(PORKLAND_DLC) or IsDLCEnabled(CAPY_DLC) then
		-- Make floatable
		MakeInventoryFloatable(inst, "idle_water", "idle")
	end
    
    inst.AnimState:SetBank("wakes_feather")
    inst.AnimState:SetBuild("wakes_feather")
    inst.AnimState:PlayAnimation("idle", true)
	
	inst:AddComponent("stackable")
	inst:AddComponent("inventoryitem")
	inst:AddComponent("inspectable")
	
	inst:AddComponent("waterproofer")
    inst.components.waterproofer.effectiveness = 0
	
	inst:AddComponent("fuel")
    inst.components.fuel.fuelvalue = TUNING.TINY_FUEL
    
	inst.components.stackable.maxsize = TUNING.STACK_SIZE_SMALLITEM
    inst.components.inventoryitem.atlasname = "images/inventoryimages/wakes_feather.xml"
	inst.components.inventoryitem.imagename = "wakes_feather"

    return inst
end


return Prefab( "common/inventory/wakes_feather", fn, assets)