local assets=
{ 
    Asset("ANIM", "anim/wakes_helmet.zip"),
    Asset("ANIM", "anim/wakes_helmet_swap.zip"), 

    Asset("ATLAS", "images/inventoryimages/wakes_helmet.xml"),
    Asset("IMAGE", "images/inventoryimages/wakes_helmet.tex"),
}

local prefabs = 
{
}

local function fn()

    local function OnEquip(inst, owner) 
        owner.AnimState:OverrideSymbol("swap_hat", "wakes_helmet", "swap_hat")
        owner.AnimState:Show("HAT")
        owner.AnimState:Show("HAT_HAIR")
        owner.AnimState:Hide("HAIR_NOHAT")
        owner.AnimState:Hide("HAIR")
        print('A')
        if owner:HasTag("player") then
            print('B')
            owner.AnimState:Hide("HEAD")
            owner.AnimState:Show("HEAD_HAIR")
        end
    end

    local function OnUnequip(inst, owner) 
        owner.AnimState:Hide("HAT")
        owner.AnimState:Hide("HAT_HAIR")
        owner.AnimState:Show("HAIR_NOHAT")
        owner.AnimState:Show("HAIR")

        if owner:HasTag("player") then
            owner.AnimState:Show("HEAD")
            owner.AnimState:Hide("HEAD_HAIR")
        end
    end

    local inst = CreateEntity()
    local trans = inst.entity:AddTransform()
    local anim = inst.entity:AddAnimState()
    MakeInventoryPhysics(inst)
	
	if IsDLCEnabled(PORKLAND_DLC) or IsDLCEnabled(CAPY_DLC) then
		-- Make floatable
		MakeInventoryFloatable(inst, "idle_water", "idle")
	end
    
    anim:SetBank("wakes_helmet")
    anim:SetBuild("wakes_helmet")
    anim:PlayAnimation("idle")
	inst:AddComponent("inspectable")
    inst:AddComponent("inventoryitem")
    inst.components.inventoryitem.imagename = "wakes_helmet"
    inst.components.inventoryitem.atlasname = "images/inventoryimages/wakes_helmet.xml"
    
    inst:AddComponent("equippable")
    inst.components.equippable.equipslot = EQUIPSLOTS.HEAD
    inst.components.equippable:SetOnEquip(OnEquip)
    inst.components.equippable:SetOnUnequip(OnUnequip)
	
	inst:AddComponent("armor")
	inst.components.armor:InitCondition(TUNING.ARMOR_FOOTBALLHAT*2.5, TUNING.ARMOR_FOOTBALLHAT_ABSORPTION)

	inst:AddComponent("waterproofer")
    inst.components.waterproofer.effectiveness = 0
	
	if IsDLCEnabled(PORKLAND_DLC) then
	inst:AddTag("venting")
	inst:AddTag("fogproof")
	end
	
    return inst
end

return  Prefab("common/inventory/wakes_helmet", fn, assets, prefabs)