local assets=
{ 
    Asset("ANIM", "anim/wakes_spear.zip"),
    Asset("ANIM", "anim/wakes_spear_swap.zip"), 
	
	Asset("ATLAS", "images/inventoryimages/wakes_spear.xml"),
    Asset("IMAGE", "images/inventoryimages/wakes_spear.tex"),
}

local function fn(colour)

    local function OnEquip(inst, owner) 
        owner.AnimState:OverrideSymbol("swap_object", "wakes_spear_swap", "wakes_spear")
        owner.AnimState:Show("ARM_carry") 
        owner.AnimState:Hide("ARM_normal") 
    end

    local function OnUnequip(inst, owner) 
        owner.AnimState:Hide("ARM_carry") 
        owner.AnimState:Show("ARM_normal") 
    end

    local inst = CreateEntity()
    local trans = inst.entity:AddTransform()
    local anim = inst.entity:AddAnimState()
    MakeInventoryPhysics(inst)
	
	if IsDLCEnabled(PORKLAND_DLC) or IsDLCEnabled(CAPY_DLC) then
		-- Make floatable
		MakeInventoryFloatable(inst, "idle_water", "idle")
	end
	
    
    anim:SetBank("wakes_spear")
    anim:SetBuild("wakes_spear")
    anim:PlayAnimation("idle")
	
	inst:AddComponent("inspectable")
	inst:AddTag("sharp")
	
	inst:AddComponent("weapon")
    inst.components.weapon:SetDamage(TUNING.SPEAR_DAMAGE*1.25)
    
    inst:AddComponent("finiteuses")
    inst.components.finiteuses:SetMaxUses(TUNING.SPEAR_USES*2.5)
    inst.components.finiteuses:SetUses(TUNING.SPEAR_USES*2.5)
	
	inst:AddComponent("waterproofer")
    inst.components.waterproofer.effectiveness = 0

    inst:AddComponent("inventoryitem")
    inst.components.inventoryitem.imagename = "wakes_spear"
    inst.components.inventoryitem.atlasname = "images/inventoryimages/wakes_spear.xml"
    
    inst:AddComponent("equippable")
    inst.components.equippable:SetOnEquip( OnEquip )
    inst.components.equippable:SetOnUnequip( OnUnequip )

    return inst
end

return  Prefab("common/inventory/wakes_spear", fn, assets)